<?php

/**===================================
 * Protecteddownload
 * ===================================
 * Enabeling the download of a .htaccess protected file
 * from folder: downloads/protected/
 * @copyright 2013-2014 by svasti@svasti.de
 * @version 1.3
 * @link http://frankziesing.de/cmsimple/?Start:Protected_Download
 *
 * Use {{{protecteddownload('full filename');}}}
 * files are supposed to be in folder downloads/protected/
 *
 * History:
 * 1.1 errormessage added, code by cmb
 * 1.2 small change in download package
 * 1.3 filenames can contain spaces (e.g. MS-Word filenames)
 */
function custom_404()
{
header('Location: ?404');
exit;
}

function protecteddownload($file)
{
    global $pth;
    $o = '';

    if (!is_readable($pth['folder']['downloads'].'protected/'.$file)) {
        e('notreadable', 'file', $pth['folder']['downloads'].'protected/'.$file);
        return;
    }

        $basename = substr($file,strpos($file,'/'));
        $basename = uenc($basename);
        $basename = str_replace(array('%','.'),'x',$basename);
        $dirname  = dirname($file);
        $filename = $dirname != '.'
            ? $dirname . '/' . $basename
            : $basename;


    if(isset($_POST['protecteddownload'.$filename]))
    {
        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename='.$file);
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: ' . filesize($pth['folder']['downloads'].'protected/'.$file));
        ob_clean();
        readfile($pth['folder']['downloads'].'protected/'.$file);
        exit();
    }

    $o .= '<form action="" style="text-align:center;" method="post">'
       .  '<p>'
       .  tag('input type="submit"
          style="cursor:pointer;font-weight:bold;letter-spacing:.2em;padding:.2em 1em;border-radius:1em;"
          value="Download: &nbsp;'
       .  $file.'" name="protecteddownload'.$filename.'"')
       . '</p></form>' . "\n";

    return $o;
}
